package core;

import java.util.List;

abstract class Tracer
{
    abstract int[][] getOrientationField();
    abstract boolean[][] getPixelMask();
    abstract int[][] getWidthMap();
    abstract List<SingleFilament> scanFilaments(boolean[][] bin, double tolerance, int min_length,
                                                int min_angle, int step);
    abstract int calcWidthMap(boolean[][] bin, double tolerance);
    abstract int[][] makeFingerprint(double axis);
}
